
module knockout (i1, i2, i3, i4, i5, i6, i7, i8, o1, o2, o3,o4, clock);
input i1, i2, i3, i4, i5, i6, i7, i8, clock;
output o1, o2, o3, o4;
wire m11, m12, m13, m14, m15, m16, m17, m18;
wire m21, m22, m23, m24, m25, m26, m27, m28;
wire m31, m32, m33, m34, m35, m36, m37, m38;
wire m41, m42, m43, m44, m45, m46, m47, m48;
wire m51, m52, m53, m54, m55, m56, m57, m58;
wire m61, m62, m63, m64, m65, m66, m67;
wire m71, m72, m73, m74, m75, m76;
wire m85;

se se11(i1, i2, m11, m12, clock);
se se12(i3, i4, m13, m14, clock); 
se se13(i5, i6, m15, m16, clock);
se se14(i7, i8, m17, m18, clock);
se se21(m11, m13, m21, m22, clock);
se se22(m15, m17, m23, m24, clock);
se se23(m12, m14, m25, m26, clock);
se se24(m16, m18, m27, m28, clock);
se se31(m21, m23, m31, m32, clock);
se se32(m25, m27, m33, m34, clock);
se se33(m22, m24, m35, m36, clock);
se se34(m26, m28, m37, m38, clock);
dr dr41(m31, m41, clock);
se se42(m33, m35, m42, m43, clock);
dr dr43(m32, m44, clock);
se se44(m37, m34, m45, m46, clock); 
dr dr45(m36, m47, clock);
dr dr46(m38, m48, clock);
dr dr51(m41, m51, clock);
se se52(m42, m44, m52, m53, clock);
se se53(m45, m47, m54, m55, clock);
dr dr54(m43, m56, clock);
se se55(m48, m46, m57, m58, clock);
dr dr61(m51, m61, clock);
dr dr62(m52, m62, clock);
se se63(m54, m56, m63, m64, clock);
dr dr64(m53, m65, clock);
se se65(m57, m55, m66, m67, clock);
dr dr71(m61, m71, clock);
dr dr72(m62, m72, clock);
se se73(m63, m65, m73, m74, clock);
se se74(m66, m64, m75, m76, clock);
dr dr81(m71, o1, clock);
dr dr82(m72, o2, clock);
dr dr83(m73, o3, clock);
se se84(m75, m74, o4, m85, clock);
endmodule
module se (i1, i2, o1, o2, clock);
input i1, i2, clock;
output o1, o2;
reg o1, o2;
initial begin
     o1 = 0;
     o2 = 0;
end
always @(posedge clock) begin
    if (i1 == 0) begin
      o1 = i2;
      o2 = i1;
    end
    else begin
      o1 = i1;
      o2 = i2;
    end
end
endmodule

module dr (i1, o1, clock);
input i1, clock;
output o1;
reg o1;
initial begin
     o1 = 0;
end
always @(posedge clock) begin
    o1 = i1;
end
endmodule
