module knockout (i1, i2, i3, i4, i5, i6, i7, i8, o1, o2, o3, o4, clock);
input i1, i2, i3, i4, i5, i6, i7, i8, clock;
output o1, o2, o3, o4;
knockout_tmp knockout0(i1, i2, i3, i4, i5, i6, i7, i8, o1, o2, o3, o4, clock);
endmodule
  
module knockout_tmp (i1, i2, i3, i4, i5, i6, i7, i8, o1, o2, o3, o4, clock);
input i1, i2, i3, i4, i5, i6, i7, i8, clock;
output o1, o2, o3, o4;
wire [3 : 0] sum;
reg o1, o2, o3, o4;
wire o11, o12, o13, o14;
reg o21, o22, o23, o24;
reg o31, o32, o33, o34;
reg o41, o42, o43, o44;
reg o51, o52, o53, o54;
reg o61, o62, o63, o64;
reg o71, o72, o73, o74;
reg o81, o82, o83, o84;
initial begin
   o1 = 0;
   o2 = 0;
   o3 = 0;
   o4 = 0;
   o21 = 0;
   o22 = 0;
   o23 = 0;
   o24 = 0;
   o31 = 0;
   o32 = 0;
   o33 = 0;
   o34 = 0;
   o41 = 0;
   o42 = 0;
   o43 = 0;
   o44 = 0;
   o51 = 0;
   o52 = 0;
   o53 = 0;
   o54 = 0;
   o61 = 0;
   o62 = 0;
   o63 = 0;
   o64 = 0;
   o71 = 0;
   o72 = 0;
   o73 = 0;
   o74 = 0;
   o81 = 0;
   o82 = 0;
   o83 = 0;
   o84 = 0;
end

assign sum = i1 + i2 + i3 + i4 + i5 + i6 + i7 + i8;
assign o11 = (sum < 1) ? 0 : 1;
assign o12 = (sum < 2) ? 0 : 1;
assign o13 = (sum < 3) ? 0 : 1;
assign o14 = (sum < 4) ? 0 : 1;
always @(posedge clock) begin
   o21 = o11;
   o22 = o12;
   o23 = o13;
   o24 = o14;
end
always @(posedge clock) begin
   o31 = o21;
   o32 = o22;
   o33 = o23;
   o34 = o24;
end
always @(posedge clock) begin
   o41 = o31;
   o42 = o32;
   o43 = o33;
   o44 = o34;
end
always @(posedge clock) begin
   o51 = o41;
   o52 = o42;
   o53 = o43;
   o54 = o44;
end
always @(posedge clock) begin
   o61 = o51;
   o62 = o52;
   o63 = o53;
   o64 = o54;
end
always @(posedge clock) begin
   o71 = o61;
   o72 = o62;
   o73 = o63;
   o74 = o64;
end
always @(posedge clock) begin
   o81 = o71;
   o82 = o72;
   o83 = o73;
   o84 = o74;
end
always @(posedge clock) begin
   o1 = o81;
   o2 = o82;
   o3 = o83;
   o4 = o84;
end
  
endmodule
